// This example shows how to connect to Cayenne using an ESP8266 and send/receive sample data.
// Make sure you install the ESP8266 Board Package via the Arduino IDE Board Manager and select the correct ESP8266 board before compiling. 

//#define CAYENNE_DEBUG
#define CAYENNE_PRINT Serial
#include <CayenneMQTTESP8266.h>

// WiFi network info.
char ssid[] = "LearnOBots Zong BOLT";
char wifiPassword[] = "m12m12mm";

// Cayenne authentication info. This should be obtained from the Cayenne Dashboard.
char username[] = "ba0f8de0-2c8a-11e7-abe9-8d4a013d1ddb";
char password[] = "1a40abdadffe7cb252c5c8510c87b92876dd69ab";
char clientID[] = "e420dc80-0831-11ea-84bb-8f71124cfdfb";

unsigned long lastMillis = 0;

void setup() {
  Serial.begin(9600);
  Cayenne.begin(username, password, clientID, ssid, wifiPassword);
  pinMode(4,OUTPUT);
  pinMode(2,OUTPUT);
  pinMode(5,OUTPUT);
  pinMode(0,OUTPUT);
    
}

void loop() {
  Cayenne.loop();

  //Publish data every 10 seconds (10000 milliseconds). Change this value to publish at a different interval.
  if (millis() - lastMillis > 10000) {
    lastMillis = millis();
    //Write data to Cayenne here. This example just sends the current uptime in milliseconds.
    Cayenne.virtualWrite(0, lastMillis);
    //Some examples of other functions you can use to send data.
    //Cayenne.celsiusWrite(1, 22.0);
    //Cayenne.luxWrite(2, 700);
    //Cayenne.virtualWrite(3, 50, TYPE_PROXIMITY, UNIT_CENTIMETER);
  }
}

//Default function for processing actuator commands from the Cayenne Dashboard.
//You can also use functions for specific channels, e.g CAYENNE_IN(1) for channel 1 commands.
CAYENNE_IN_DEFAULT()
{
  CAYENNE_LOG("CAYENNE_IN_DEFAULT(%u) - %s, %s", request.channel, getValue.getId(), getValue.asString());
  //Process message here. If there is an error set an error message using getValue.setError(), e.g getValue.setError("Error message");
}

CAYENNE_IN(2)
{
  digitalWrite(2,getValue.asInt());
}

CAYENNE_IN(4)
{
  digitalWrite(4,getValue.asInt());
}

CAYENNE_IN(5)
{
  digitalWrite(5,getValue.asInt());
}

CAYENNE_IN(0)
{
  digitalWrite(0,getValue.asInt());
}
